/* Intrinsics for LoongArch vz operations.

   Copyright (C) 2019 Free Software Foundation, Inc.
   Contributed by xuchenghua@loongson.cn.

   This file is part of GCC.

   GCC is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 3, or (at your
   option) any later version.

   GCC is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   Under Section 7 of GPL version 3, you are granted additional
   permissions described in the GCC Runtime Library Exception, version
   3.1, as published by the Free Software Foundation.

   You should have received a copy of the GNU General Public License and
   a copy of the GCC Runtime Library Exception along with this program;
   see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
   <http://www.gnu.org/licenses/>.  */

#ifndef _GCC_LOONGARCH_LVZ_H
#define _GCC_LOONGARCH_LVZ_H

#define __lvz_gcsrrd	__builtin_lvz_gcsrrd
#define __lvz_gcsrwr	__builtin_lvz_gcsrwr
#define __lvz_gcsrxchg __builtin_lvz_gcsrxchg
#define __lvz_dgcsrrd	__builtin_lvz_dgcsrrd
#define __lvz_dgcsrwr	__builtin_lvz_dgcsrwr
#define __lvz_dgcsrxchg __builtin_lvz_dgcsrxchg

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbsrch (void)
{
  __asm__ volatile ("gtlbsrch\n\t");
}
#define __lvz_gtlbsrch __builtin_lvz_gtlbsrch

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbrd (void)
{
  __asm__ volatile ("gtlbrd\n\t");
}
#define __lvz_gtlbrd __builtin_lvz_gtlbrd

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbwr (void)
{
  __asm__ volatile ("gtlbwr\n\t");
}
#define __lvz_gtlbwr __builtin_lvz_gtlbwr

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbfill (void)
{
  __asm__ volatile ("gtlbfill\n\t");
}
#define __lvz_gtlbfill __builtin_lvz_gtlbfill

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbclr (void)
{
  __asm__ volatile ("gtlbclr\n\t");
}
#define __lvz_gtlbclr __builtin_lvz_gtlbclr

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_gtlbflush (void)
{
  __asm__ volatile ("gtlbflush\n\t");
}
#define __lvz_gtlbflush __builtin_lvz_gtlbflush

extern __inline void __attribute__((__gnu_inline__, __always_inline__, __artificial__))
__builtin_lvz_hvcl (void)
{
  __asm__ volatile ("hvcl\n\t");
}
#define __lvz_hvcl __builtin_lvz_hvcl


#endif /*_GCC_LOONGARCH_LVZ_H */
